<?php

class LeadiflyActivecampaign
{
    protected $api_key;
    protected $list_id;
    protected $api_url;
    public $valid;

    public function __construct()
    {
        $leadify_option = get_option('leadifly_options');
        $this->options = $leadify_option;

        if (isset($leadify_option['activecampaign_app_id']) &&
            $leadify_option['activecampaign_app_id'] != '' &&
            isset($leadify_option['activecampaign_list_id']) &&
            $leadify_option['activecampaign_list_id'] != ''
        ) {
            $this->api_key = $leadify_option['activecampaign_app_id'];
            $this->list_id = $leadify_option['activecampaign_list_id'];
            $this->api_url = $leadify_option['activecampaign_api_url'];
        }

        if (isset($this->options['activecampaign_valid']))
            $this->valid = $this->options['activecampaign_valid'];
    }

    public function testAuth()
    {
        $data = [
            'email' => 'random',
            'first_name' => 'John',
            'last_name' => 'Doe'
        ];

        return $this->addSubscriberToList($data, true);
    }

    function addSubscriberToList($data, $is_test = false)
    {
        $params = array(
            'api_key' => $this->api_key,
            'api_action' => 'contact_add',
        );

        $post = array(
            'email' => $data['email'],
            'p[' . $this->list_id . ']' => $this->list_id,
            'status[' . $this->list_id . ']' => 1,
            'first_name' => $data['first_name'],
            'last_name' => $data['last_name']
        );

        $query = "";
        foreach ($params as $key => $value) $query .= urlencode($key) . '=' . urlencode($value) . '&';
        $query = rtrim($query, '& ');

        $data = "";
        foreach ($post as $key => $value) $data .= urlencode($key) . '=' . urlencode($value) . '&';
        $data = rtrim($data, '& ');

        $url = rtrim($this->api_url, '/ ');
        $api = $url . '/admin/api.php?' . $query;

        $ch = curl_init($api);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        $response = curl_exec($ch);
        $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        curl_close($ch);

        if ($httpCode == 401) {
            $this->options['activecampaign_valid'] = 0;
            update_option('leadifly_options', $this->options);
            return false;
        }

        if ($is_test) {
            $this->options['activecampaign_valid'] = 1;
            update_option('leadifly_options', $this->options);
        }

        return true;
    }
}