<?php

class LeadiflyGetresponse
{
    protected $api_key;
    protected $campaign_id;
    protected $options;
    public $valid;

    public function __construct()
    {
        $leadify_option = get_option('leadifly_options');
        $this->options = $leadify_option;

        if (isset($leadify_option['getresponse_app_id']) &&
            $leadify_option['getresponse_app_id'] != '' &&
            isset($leadify_option['getresponse_campaign_id']) &&
            $leadify_option['getresponse_campaign_id'] != ''
        ) {
            $this->api_key = $leadify_option['getresponse_app_id'];
            $this->campaign_id = $leadify_option['getresponse_campaign_id'];
        }

        if (isset($this->options['getresponse_valid']))
            $this->valid = $this->options['getresponse_valid'];
    }

    public function testAuth()
    {
        $data = [
            'email' => 'random',
            'first_name' => 'John',
            'last_name' => 'Doe'
        ];

        return $this->addSubscriberToCampaign($data, true);
    }

    function addSubscriberToCampaign($data, $is_test = false)
    {
        $url = 'https://api.getresponse.com/v3/contacts';

        $json = json_encode([
            'email' => $data['email'],
            'name' => $data['first_name'] . ' ' . $data['last_name'],
           // 'ipAddress' => '195.100.100.1',
            'campaign' => array('campaignId' => $this->campaign_id),
        ]);

        $ch = curl_init($url);
        $headers = [
            'Content-Type: application/json',
            'X-Auth-Token: api-key ' . $this->api_key,
        ];
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
        $result = curl_exec($ch);
        $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        curl_close($ch);

        if ($httpCode == 401) {
            $this->options['getresponse_valid'] = 0;
            update_option('leadifly_options', $this->options);
            return false;
        }

        if ($is_test) {
            $this->options['getresponse_valid'] = 1;
            update_option('leadifly_options', $this->options);
        }

        return true;
    }
}