<?php

class LeadiflyMailChimp
{
    protected $api_key;
    protected $list_id;
    protected $options;
    public $valid;

    public function __construct()
    {
        $leadify_option = get_option('leadifly_options');
        $this->options = $leadify_option;

        if (isset($leadify_option['mailchimp_app_id']) &&
            $leadify_option['mailchimp_app_id'] != '' &&
            isset($leadify_option['mailchimp_list_id']) &&
            $leadify_option['mailchimp_list_id'] != ''
        ) {
            $this->api_key = $leadify_option['mailchimp_app_id'];
            $this->list_id = $leadify_option['mailchimp_list_id'];
        }

        if (isset($this->options['mailchimp_valid']))
            $this->valid = $this->options['mailchimp_valid'];

    }

    public function testAuth()
    {
        $data = [
            'email' => 'random',
            'first_name' => 'John',
            'last_name' => 'Doe'
        ];

        return $this->addSubscriberToList($data, true);
    }

    function addSubscriberToList($data, $is_test = false)
    {
        $email = $data['email'];
        $memberID = md5(strtolower($email));
        $dataCenter = substr($this->api_key, strpos($this->api_key, '-') + 1);
        $url = 'https://' . $dataCenter . '.api.mailchimp.com/3.0/lists/' . $this->list_id . '/members/' . $memberID;
        $json = json_encode([
            'email_address' => $email,
            'status' => 'subscribed',
            'merge_fields' => [
                'FNAME' => $data['first_name'],
                'LNAME' => $data['last_name']
            ]
        ]);
        $ch = curl_init($url);
        curl_setopt($ch, CURLOPT_USERPWD, 'user:' . $this->api_key);
        curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);
        curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $json);
        $result = curl_exec($ch);
        $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        curl_close($ch);

        if ($httpCode == 401) {
            $this->options['mailchimp_valid'] = 0;
            update_option('leadifly_options', $this->options);
            return false;
        }

        if ($is_test) {
            $this->options['mailchimp_valid'] = 1;
            update_option('leadifly_options', $this->options);
        }

        return true;
    }
}