<?php

class LeadiflySendlane
{
    protected $api_key;
    protected $list_id;
    protected $hash_key;
    protected $domain;
    protected $options;
    public $valid;

    public function __construct()
    {
        $leadify_option = get_option('leadifly_options');
        $this->options = $leadify_option;

        if (isset($leadify_option['sendlane_app_id']) &&
            $leadify_option['sendlane_app_id'] != '' &&
            isset($leadify_option['sendlane_list_id']) &&
            $leadify_option['sendlane_list_id'] != '' &&
            isset($leadify_option['sendlane_hash_id']) &&
            $leadify_option['sendlane_hash_id'] != '' &&
            isset($leadify_option['sendlane_domain']) &&
            $leadify_option['sendlane_domain'] != ''
        ) {
            $this->api_key = $leadify_option['sendlane_app_id'];
            $this->list_id = $leadify_option['sendlane_list_id'];
            $this->hash_key = $leadify_option['sendlane_hash_id'];
            $this->domain = $leadify_option['sendlane_domain'];
        }

        if (isset($this->options['sendlane_valid']))
            $this->valid = $this->options['sendlane_valid'];
    }

    public function testAuth()
    {
        $data = [
            'email' => 'random',
            'first_name' => 'John',
            'last_name' => 'Doe'
        ];

        return $this->addSubscriberToList($data, true);
    }

    public function addSubscriberToList($data, $is_test = false)
    {
        $url = 'https://' . $this->domain . '/api/v1/list-subscribers-add';

        $params = array(
            'api' => $this->api_key,
            'hash' => $this->hash_key,
            'list_id' => $this->list_id,
            'email' => $data['email'],
            'first_name' => $data['first_name'],
            'last_name' => $data['last_name']
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
        $result = curl_exec($ch);
        $result = json_decode($result, true);

        if (isset($result['error']['401'])) {
            $this->options['sendlane_valid'] = 0;
            update_option('leadifly_options', $this->options);
            return false;
        }

        if ($is_test) {
            $this->options['sendlane_valid'] = 1;
            update_option('leadifly_options', $this->options);
        }

        return true;
    }
}