<?php
session_start();
function leadifly_register_settings()
{
    register_setting(
        'leadifly_options',
        'leadifly_options',
        'leadifly_validate_options'
    );

    //Facebook
    add_settings_section(
        'leadifly_section_general',
        'Facebook Settings',
        'leadifly_callback_section_general',
        'leadifly_general'
    );

    add_settings_field(
        'fb_app_id',
        'Facebook App ID',
        'leadifly_callback_field_text',
        'leadifly_general',
        'leadifly_section_general',
        ['id' => 'fb_app_id', 'label' => 'Checkout <a href="https://developers.facebook.com/apps/" target="_blank">Facebook Developer</a> documentation.']
    );

    add_settings_field(
        'fb_app_secret',
        'Facebook App Secret',
        'leadifly_callback_field_text',
        'leadifly_general',
        'leadifly_section_general',
        ['id' => 'fb_app_secret', 'label' => 'Facebook App Secret']
    );

    add_settings_field(
        'facebook_valid',
        '',
        'leadifly_callback_hidden',
        'leadifly_general',
        'leadifly_section_general',
        ['id' => 'facebook_valid']
    );

    //MailChimp
    add_settings_section(
        'leadifly_section_mailchimp',
        'MailChimp Settings',
        'leadifly_callback_section_mailchimp',
        'leadifly_mailchimp'
    );

    add_settings_field(
        'mailchimp_app_id',
        'API Key',
        'leadifly_callback_field_text',
        'leadifly_mailchimp',
        'leadifly_section_mailchimp',
        ['id' => 'mailchimp_app_id', 'label' => 'Find it on MailChimp Account page']
    );

    add_settings_field(
        'mailchimp_list_id',
        'List ID',
        'leadifly_callback_field_text',
        'leadifly_mailchimp',
        'leadifly_section_mailchimp',
        ['id' => 'mailchimp_list_id', 'label' => 'Find it on List details page']
    );

    add_settings_field(
        'mailchimp_valid',
        '',
        'leadifly_callback_hidden',
        'leadifly_mailchimp',
        'leadifly_section_mailchimp',
        ['id' => 'mailchimp_valid']
    );

    add_settings_field(
        'mailchimp_active',
        'Use MailChimp',
        'leadifly_callback_checkbox',
        'leadifly_mailchimp',
        'leadifly_section_mailchimp',
        ['id' => 'mailchimp_active']
    );

    //Active Campaign
    add_settings_section(
        'leadifly_section_activecampaign',
        'Active Campaign Settings',
        'leadifly_callback_section_activecampaign',
        'leadifly_activecampaign'
    );

    add_settings_field(
        'activecampaign_app_id',
        'API Key',
        'leadifly_callback_field_text',
        'leadifly_activecampaign',
        'leadifly_section_activecampaign',
        ['id' => 'activecampaign_app_id', 'label' => 'Find it in Developer Settings of your Active Campaign account.']
    );

    add_settings_field(
        'activecampaign_list_id',
        'List ID',
        'leadifly_callback_field_text',
        'leadifly_activecampaign',
        'leadifly_section_activecampaign',
        ['id' => 'activecampaign_list_id', 'label' => 'When you visit list page checkout address bar and there you will see listid parameter.']
    );

    add_settings_field(
        'activecampaign_api_url',
        'API Url',
        'leadifly_callback_field_text',
        'leadifly_activecampaign',
        'leadifly_section_activecampaign',
        ['id' => 'activecampaign_api_url', 'label' => 'Url from API Access section.']
    );

    add_settings_field(
        'activecampaign_valid',
        '',
        'leadifly_callback_hidden',
        'leadifly_activecampaign',
        'leadifly_section_activecampaign',
        ['id' => 'activecampaign_valid']
    );

    add_settings_field(
        'activecampaign_active',
        'Use Active Campaign',
        'leadifly_callback_checkbox',
        'leadifly_activecampaign',
        'leadifly_section_activecampaign',
        ['id' => 'activecampaign_active']
    );

    //Get Response
    add_settings_section(
        'leadifly_section_getresponse',
        'Get Response Settings',
        'leadifly_callback_section_getresponse',
        'leadifly_getresponse'
    );

    add_settings_field(
        'getresponse_app_id',
        'API Key',
        'leadifly_callback_field_text',
        'leadifly_getresponse',
        'leadifly_section_getresponse',
        ['id' => 'getresponse_app_id', 'label' => '']
    );

    add_settings_field(
        'getresponse_campaign_id',
        'Campaign ID',
        'leadifly_callback_field_text',
        'leadifly_getresponse',
        'leadifly_section_getresponse',
        ['id' => 'getresponse_campaign_id', 'label' => '']
    );

    add_settings_field(
        'getresponse_valid',
        '',
        'leadifly_callback_hidden',
        'leadifly_getresponse',
        'leadifly_section_getresponse',
        ['id' => 'getresponse_valid']
    );

    add_settings_field(
        'getresponse_active',
        'Use GetResponse',
        'leadifly_callback_checkbox',
        'leadifly_getresponse',
        'leadifly_section_getresponse',
        ['id' => 'getresponse_active']
    );

    //Sendlane
    add_settings_section(
        'leadifly_section_sendlane',
        'Sendlane Settings',
        'leadifly_callback_section_sendlane',
        'leadifly_sendlane'
    );

    add_settings_field(
        'sendlane_app_id',
        'API Key',
        'leadifly_callback_field_text',
        'leadifly_sendlane',
        'leadifly_section_sendlane',
        ['id' => 'sendlane_app_id', 'label' => 'API key']
    );

    add_settings_field(
        'sendlane_hash_id',
        'Hash Key',
        'leadifly_callback_field_text',
        'leadifly_sendlane',
        'leadifly_section_sendlane',
        ['id' => 'sendlane_hash_id', 'label' => 'Hash key']
    );

    add_settings_field(
        'sendlane_domain',
        'Domain',
        'leadifly_callback_field_text',
        'leadifly_sendlane',
        'leadifly_section_sendlane',
        ['id' => 'sendlane_domain', 'label' => 'Enter it like this example.sendlane.com Without trailing slashes or http prefix.']
    );

    add_settings_field(
        'sendlane_list_id',
        'List ID',
        'leadifly_callback_field_text',
        'leadifly_sendlane',
        'leadifly_section_sendlane',
        ['id' => 'sendlane_list_id', 'label' => 'When you visit list page find id parameter in address bar.']
    );

    add_settings_field(
        'sendlane_valid',
        '',
        'leadifly_callback_hidden',
        'leadifly_sendlane',
        'leadifly_section_sendlane',
        ['id' => 'sendlane_valid']
    );

    add_settings_field(
        'sendlane_active',
        'Use Sendlane',
        'leadifly_callback_checkbox',
        'leadifly_sendlane',
        'leadifly_section_sendlane',
        ['id' => 'sendlane_active']
    );

    //Aweber
    add_settings_section(
        'leadifly_section_aweber',
        'Aweber Settings',
        'leadifly_callback_section_aweber',
        'leadifly_aweber'
    );

    add_settings_field(
        'aweber_consumer_key',
        'Consumer Key',
        'leadifly_callback_field_text',
        'leadifly_aweber',
        'leadifly_section_aweber',
        ['id' => 'aweber_consumer_key', 'label' => 'Consumer key']
    );

    add_settings_field(
        'aweber_consumer_secret',
        'Consumer Secret',
        'leadifly_callback_field_text',
        'leadifly_aweber',
        'leadifly_section_aweber',
        ['id' => 'aweber_consumer_secret', 'label' => 'Consumer secret']
    );

    add_settings_field(
        'aweber_list_id',
        'List ID',
        'leadifly_callback_field_text',
        'leadifly_aweber',
        'leadifly_section_aweber',
        ['id' => 'aweber_list_id', 'label' => 'List ID']
    );

    add_settings_field(
        'aweber_valid',
        '',
        'leadifly_callback_hidden',
        'leadifly_aweber',
        'leadifly_section_aweber',
        ['id' => 'aweber_valid']
    );

    add_settings_field(
        'aweber_code_authorized',
        '',
        'leadifly_callback_hidden',
        'leadifly_aweber',
        'leadifly_section_aweber',
        ['id' => 'aweber_code_authorized']
    );

    add_settings_field(
        'aweber_request_token',
        '',
        'leadifly_callback_hidden',
        'leadifly_aweber',
        'leadifly_section_aweber',
        ['id' => 'aweber_request_token']
    );

    add_settings_field(
        'aweber_token_secret',
        '',
        'leadifly_callback_hidden',
        'leadifly_aweber',
        'leadifly_section_aweber',
        ['id' => 'aweber_token_secret']
    );

    add_settings_field(
        'aweber_code',
        'Code',
        'leadifly_callback_disabled',
        'leadifly_aweber',
        'leadifly_section_aweber',
        ['id' => 'aweber_code']
    );

    add_settings_field(
        'aweber_access_token',
        'Access Token',
        'leadifly_callback_disabled',
        'leadifly_aweber',
        'leadifly_section_aweber',
        ['id' => 'aweber_access_token']
    );

    add_settings_field(
        'aweber_access_secret',
        'Access Secret',
        'leadifly_callback_disabled',
        'leadifly_aweber',
        'leadifly_section_aweber',
        ['id' => 'aweber_access_secret']
    );

    add_settings_field(
        'aweber_active',
        'Use Aweber',
        'leadifly_callback_checkbox',
        'leadifly_aweber',
        'leadifly_section_aweber',
        ['id' => 'aweber_active']
    );

}

add_action('admin_init', 'leadifly_register_settings');

function validate_leadifly_options($api)
{

    switch($api) {
        case 'facebook':
            require_once plugin_dir_path(__FILE__) . 'fb-api.php';
            $fb = new LeadiflyFBApi();
            $fb->getApplicationToken();
            break;
        case 'mailchimp':
            require_once plugin_dir_path(__FILE__) . 'apis/mailchimp.php';
            $mailchimp = new LeadiflyMailChimp();
            $mailchimp->testAuth();
            break;
        case 'activecampaign':
            require_once plugin_dir_path(__FILE__) . 'apis/activecampaign.php';
            $activecampaign = new LeadiflyActivecampaign();
            $activecampaign->testAuth();
            break;
        case 'getresponse':
            require_once plugin_dir_path(__FILE__) . 'apis/getresponse.php';
            $mailchimp = new LeadiflyGetresponse();
            $mailchimp->testAuth();
            break;
        case 'sendlane':
            require_once plugin_dir_path(__FILE__) . 'apis/sendlane.php';
            $sendlane = new LeadiflySendlane();
            $sendlane->testAuth();
            break;
        case 'aweber':
            require_once plugin_dir_path(__FILE__) . 'apis/aweber.php';
            $aweber = new LeadiflyAweber();
            $aweber->testAuth();
            break;
    }
}

function authorize_aweber_code()
{
    require_once plugin_dir_path(__FILE__) . 'apis/aweber.php';
    $aweber = new LeadiflyAweber();

    if (!isset($aweber->options['aweber_code']) || $aweber->options['aweber_code'] == '') {
        wp_die('Aweber code is undefined.');
    }

    $aweber->authorizeCode();
}

function leadifly_callback_section_general()
{
    echo '<p>Installation Steps:</p>';
    echo '<ol>';
    echo '<li>Go to <a href="https://developers.facebook.com/" target="_blank">Facebook for developers</a> -> My Apps -> Add a New App</li>';
    echo '<li>In new app Settings in App Domains enter: <code>'. site_url() .'</code> and Save</li>';
    echo '<li>In Products section add Facebook Login for Web, as Site URL enter same as above and Save (ignore other tabs).</li>';
    echo '<li>Go To Facebook Login Settings Page, and enter <code>'. admin_url() . 'admin-post.php?action=fb_callback' .'</code> as <b>Valid OAuth redirect URI</b> and Save</li>';
    echo '<li>Go to App main Settings click Add Platform and choose <b>Facebook Web Games</b></li>';
    echo '<li>New Settings section will appear for Web Game, in field <b>Facebook Web Games URL (https)</b> enter <code>'. site_url() . '/fbl/' .'</code></li>';
    echo '<li>Now you need to make your app Live. Go to App Review page and in first section Make app public switch button from No to Yes. Choose category and Submit. You should see text: <b>Your app is currently live, but requires review before it\'s available to the public.</b></li>';
    echo '</ol>';
    echo '<p>You have completed all the steps. Our app does not need to be public cause we won\'t list it in the App Store.</p>';
    echo '<p>After you Save your new credentials click <b>Validate Settings</b> button, if it is visible.';
}

function leadifly_callback_section_mailchimp()
{
    echo '<p>You can find these credentials in your MailChimp account.</p>';
    echo '<p>After you Save your new credentials click <b>Validate Settings</b> button, if it is visible.';
    get_clean_settings_string('mailchimp', 'MailChimp');
}

function leadifly_callback_section_activecampaign()
{
    echo '<p>After you Save your new credentials click <b>Validate Settings</b> button, if it is visible.';
    get_clean_settings_string('activecampaign', 'Active Campaign');
}

function leadifly_callback_section_getresponse()
{
    echo '<p>After you Save your new credentials click <b>Validate Settings</b> button, if it is visible.';
    get_clean_settings_string('getresponse', 'Get Response');

}

function leadifly_callback_section_sendlane()
{
    echo '<p>After you Save your new credentials click <b>Validate Settings</b> button, if it is visible.';
    get_clean_settings_string('sendlane', 'Sendlane');
}

function leadifly_callback_section_aweber()
{
    echo "<p>Aweber API is the most complicated, so we've written special guide. It requires private app to be created on their Labs site, before external systems can interact with your Aweber account. 
    
    Checkout steps bellow:</p>";
    echo
    "<ol>" .
    "<li>Go to <a href='https://labs.aweber.com/auth/login' target='_blank'>Aweber Labs</a> create new account there and create private app.</li>" .
    "<li>Go to settings of that private app and copy <b>Consumer Key</b> and <b>Consumer Secret</b>.</li>" .
    "<li>Copy <b>List ID</b> from your Aweber account (only numbers part) and click <b>Save Changes</b> here.</li>" .
    "<li>Now you need to give permission to this newly created app to access your Aweber account. <a href='" . plugin_dir_url(__FILE__) ."aweber-code.php'>Click here</a> to authorize it.</li>" .
    "<li>If everything went well <b>Code</b> value here should be not empty</li>".
    "<li>Last part is to verify this code and get <b>Access Token</b> and <b>Access Secret</b> <a href='". plugin_dir_url(__FILE__) . "aweber-code-authorize.php'>Click here</a> to get them.</li>".
    "</ol>";

    echo "<p>If something went wrong please repeat steps 4,5 and 6.</p>";
    echo '<p>After you Save your new credentials click <b>Validate Settings</b> button, if it is visible.';
    get_clean_settings_string('aweber', 'Aweber');
}

function get_clean_settings_string($api, $name)
{
    echo '<p>You can delete ' . $name . ' settings <a href="' . plugin_dir_url(__FILE__) . 'settings-clean.php?api=' . $api . '" style="color:red;" onclick="return confirm(\'Are you sure you want to delete ' . $name . ' settings?\')">here</a>.</p>';
}

function leadifly_validate_options($input)
{
    return $input;
}

function leadifly_callback_field_text( $args ) {

    $options = get_option( 'leadifly_options', leadifly_options_default() );

    $id    = isset( $args['id'] )    ? $args['id']    : '';
    $label = isset( $args['label'] ) ? $args['label'] : '';

    $value = isset( $options[$id] ) ? sanitize_text_field( $options[$id] ) : '';

    echo '<input id="leadifly_options_'. $id .'" name="leadifly_options['. $id .']" type="text" size="50" value="'. $value .'"><br />';
    echo '<label for="leadifly_options_'. $id .'">'. $label .'</label>';

}

function leadifly_callback_hidden( $args )
{
    $options = get_option( 'leadifly_options', leadifly_options_default() );

    $id    = isset( $args['id'] )    ? $args['id']    : '';

    $value = isset( $options[$id] ) ? sanitize_text_field( $options[$id] ) : '';

    echo '<input id="leadifly_options_'. $id .'" name="leadifly_options['. $id .']" type="hidden" class="hidden-leadifly-field" value="'. $value .'">';

}

function leadifly_callback_disabled( $args )
{
    $options = get_option( 'leadifly_options', leadifly_options_default() );

    $id    = isset( $args['id'] )    ? $args['id']    : '';
    $label = isset( $args['label'] ) ? $args['label'] : '';

    $value = isset( $options[$id] ) ? sanitize_text_field( $options[$id] ) : '';

    echo '<input id="leadifly_options_'. $id .'" name="leadifly_options['. $id .']" type="text" size="50" readonly class="" value="'. $value .'">';
    echo '<label for="leadifly_options_'. $id .'">'. $label .'</label>';

}


function leadifly_callback_checkbox( $args )
{
    $options = get_option( 'leadifly_options', leadifly_options_default() );

    $id    = isset( $args['id'] )    ? $args['id']    : '';
    $label = isset( $args['label'] ) ? $args['label'] : '';

    $value = isset( $options[$id] ) && $options[$id] == true ? true : false;

    echo '<input id="leadifly_options_'. $id .'" name="leadifly_options['. $id .']" type="checkbox" class="" value="1" ' . checked(1, $value, false) . '>';
    echo '<label for="leadifly_options_'. $id .'">'. $label .'</label>';

}

function leadifly_options_default()
{

    return array(
        'fb_app_id' => '',
        'fb_app_secret' => '',
        'mailchimp_app_id' => '',
        'mailchimp_valid' => 0,
        'facebook_valid' => 0,
        'activecampaign_valid' => 0,
        'getresponse_valid' => 0,
        'sendlane_valid' => 0,
        'aweber_valid' => 0
    );

}